ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC vs.
Revision 1.45 by root, Sun Jun 26 17:26:52 2011 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11MAKE=make 12MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 13PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc 14PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 18
18ARCH="$(uname -m)" 19ARCH="$(uname -m)"
19 20
20case "$ARCH" in 21case "$ARCH" in
29esac 30esac
30 31
31# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 38
37# some configuration options for modules 39# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT CORO_INTERFACE EV_EXTRA_DEFS
41 45
42# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
43# required by mkbundle 47# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 49
46# which extra modules you might want to install 50# which extra modules you might want to install
47EXTRA_MODULES="" 51EXTRA_MODULES=""
48 52
49# overridable functions 53# overridable functions
50preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
51postconfigure() { : ; } 56postconfigure() { : ; }
52postbuild() { : ; } 57postbuild() { : ; }
53postinstall() { : ; } 58postinstall() { : ; }
54 59
55# now source user config, if any 60# now source user config, if any
62fi 67fi
63 68
64############################################################################# 69#############################################################################
65# support 70# support
66 71
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 72PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69 73
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 74unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
75unset PERL_MB_OPT
71export LC_ALL=C # just to be on the safe side 76LC_ALL=C; export LC_ALL # just to be on the safe side
77
78# prepend PATH - not required by staticperl itself, but might make
79# life easier when working in e.g. "staticperl cpan / look"
80PATH="$PERL_PREFIX/perl/bin:$PATH"
72 81
73# set version in a way that Makefile.PL can extract 82# set version in a way that Makefile.PL can extract
74VERSION=VERSION; eval \ 83VERSION=VERSION; eval \
75$VERSION=0.912 84$VERSION="1.31"
76 85
77BZ2=bz2 86BZ2=bz2
78BZIP2=bzip2 87BZIP2=bzip2
79 88
80fatal() { 89fatal() {
139 148
140 mkdir -p src 149 mkdir -p src
141 rcd src 150 rcd src
142 151
143 if ! [ -d "perl-$PERL_VERSION" ]; then 152 if ! [ -d "perl-$PERL_VERSION" ]; then
144 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 153 PERLTAR=perl-$PERL_VERSION.tar.$BZ2
145 154
155 if ! [ -e $PERLTAR ]; then
146 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 156 URL="$CPAN/src/5.0/$PERLTAR"
147 157
148 verblock <<EOF 158 verblock <<EOF
149downloading perl 159downloading perl
150to manually download perl yourself, place 160to manually download perl yourself, place
151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 161perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
152trying $URL 162trying $URL
153EOF
154 163
164either curl or wget is required for automatic download.
165curl is tried first, then wget.
166
167you can configure a download cache directory via DLCACHE
168in your .staticperlrc to avoid repeated downloads.
169EOF
170
155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 171 rm -f $PERLTAR~ # just to be on the safe side
156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 172 { [ "$DLCACHE" ] && cp -l "$DLCACHE"/$PERLTAR $PERLTAR~; } \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 173 || wget -O $PERLTAR~ "$URL" \
174 || curl -f >$PERLTAR~ "$URL" \
158 || fatal "$URL: unable to download" 175 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2 176 rm -f $PERLTAR
160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 177 mv $PERLTAR~ $PERLTAR
178 if [ "$DLCACHE" ]; then
179 mkdir -p "$DLCACHE"
180 cp -l $PERLTAR "$DLCACHE"/$PERLTAR~ && \
181 mv "$DLCACHE"/$PERLTAR~ "$DLCACHE"/$PERLTAR
182 fi
161 fi 183 fi
162 184
163 verblock <<EOF 185 verblock <<EOF
164unpacking perl 186unpacking perl
165EOF 187EOF
166 188
167 mkdir -p unpack 189 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION 190 rm -rf unpack/perl-$PERL_VERSION
169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 191 $BZIP2 -d <$PERLTAR | ( cd unpack && tar xf - ) \
170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 192 || fatal "$PERLTAR: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION 193 chmod -R u+w unpack/perl-$PERL_VERSION
172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 194 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
173 rmdir -p unpack 195 rmdir -p unpack
174 fi 196 fi
175} 197}
226 248
227 # I hate them for this 249 # I hate them for this
228 grep -q -- -fstack-protector Configure && \ 250 grep -q -- -fstack-protector Configure && \
229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 251 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230 252
231 preconfigure 253 # what did that bloke think
254 grep -q -- usedl=.define hints/darwin.sh && \
255 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
256
257 preconfigure || fatal "preconfigure hook failed"
232 258
233# trace configure \ 259# trace configure \
234 sh Configure -Duselargefiles \ 260 sh Configure -Duselargefiles \
235 -Uuse64bitint \ 261 -Uuse64bitint \
236 -Dusemymalloc=n \ 262 -Dusemymalloc=n \
238 -Uusethreads \ 264 -Uusethreads \
239 -Uuseithreads \ 265 -Uuseithreads \
240 -Uusemultiplicity \ 266 -Uusemultiplicity \
241 -Uusesfio \ 267 -Uusesfio \
242 -Uuseshrplib \ 268 -Uuseshrplib \
269 -Uinstallusrbinperl \
243 -A ccflags=" $PERL_CCFLAGS" \ 270 -A ccflags=" $PERL_CCFLAGS" \
244 -Dcc="$PERL_CC" \ 271 -Dcc="$PERL_CC" \
245 -Doptimize="$PERL_OPTIMIZE" \ 272 -Doptimize="$PERL_OPTIMIZE" \
246 -Dldflags="$PERL_LDFLAGS" \ 273 -Dldflags="$PERL_LDFLAGS" \
247 -Dlibs="$PERL_LIBS" \ 274 -Dlibs="$PERL_LIBS" \
267 sedreplace ' 294 sedreplace '
268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 295 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
269 s/ *-fno-stack-protector */ /g 296 s/ *-fno-stack-protector */ /g
270 ' config.sh 297 ' config.sh
271 298
299 patchconfig || fatal "patchconfig hook failed"
300
272 sh Configure -S || fatal "Configure -S failed" 301 sh Configure -S || fatal "Configure -S failed"
273 302
274 postconfigure || fatal "postconfigure hook failed" 303 postconfigure || fatal "postconfigure hook failed"
275 304
276 touch staticstamp.configure 305 touch staticstamp.configure
306}
307
308write_shellscript() {
309 {
310 echo "#!/bin/sh"
311 echo "STATICPERL=\"$STATICPERL\""
312 echo "PERL_PREFIX=\"$PERL_PREFIX\""
313 echo "MAKE=\"$MAKE\""
314 cat
315 } >"$PERL_PREFIX/bin/$1"
316 chmod 755 "$PERL_PREFIX/bin/$1"
277} 317}
278 318
279build() { 319build() {
280 configure 320 configure
281 321
302EOF 342EOF
303 343
304 ln -sf "perl/bin/" "$STATICPERL/bin" 344 ln -sf "perl/bin/" "$STATICPERL/bin"
305 ln -sf "perl/lib/" "$STATICPERL/lib" 345 ln -sf "perl/lib/" "$STATICPERL/lib"
306 346
347 mkdir "$STATICPERL/patched"
348
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 349 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf 350 rm -rf "$PERL_PREFIX" # by this rm -rf
309 351
310 "$MAKE" install || fatal "make install: error while installing" 352 "$MAKE" install || fatal "make install: error while installing"
311 353
312 rcd "$PERL_PREFIX" 354 rcd "$PERL_PREFIX"
313 355
314 # create a "make install" replacement for CPAN 356 # create a "make install" replacement for CPAN
315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 357 write_shellscript SP-make-install-make <<'EOF'
316"$MAKE" || exit 358#CAT make-install-make.sh
317
318if find blib/arch/auto -type f | grep -q -v .exists; then
319 echo Probably an XS module, rebuilding perl
320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
322 && rm -f "$PERL_PREFIX"/bin/perl \
323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
329fi
330
331"$MAKE" install UNINST=1
332EOF 359EOF
333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
334 360
361 # create a "patch modules" helper
362 write_shellscript SP-patch-postinstall <<'EOF'
363#CAT patch-postinstall.sh
364EOF
365
366 "$PERL_PREFIX/bin/SP-patch-postinstall"
367
335 # trick CPAN into avoiding ~/.cpan completely 368 # help to trick CPAN into avoiding ~/.cpan completely
336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 369 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
337 370
371 # we call cpan with -MCPAN::MyConfig in this script, which
372 # is strictly unnecssary as we have to patch CPAN anyway,
373 # so consider it "for good measure".
338 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 374 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 375 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 376 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
341 CPAN::Shell->o (conf => q<init>); 377 CPAN::Shell->o (conf => q<init>);
342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 378 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 379 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 380 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 381 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 382 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 383 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 384 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 385 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
386 CPAN::Shell->o (conf => q<prefer_installer>, "EUMM");
350 CPAN::Shell->o (conf => q<commit>); 387 CPAN::Shell->o (conf => q<commit>);
351 ' || fatal "error while initialising CPAN" 388 ' || fatal "error while initialising CPAN"
352 389
353 touch "$PERL_PREFIX/staticstamp.install" 390 touch "$PERL_PREFIX/staticstamp.install"
354 fi 391 fi
374installing modules from CPAN 411installing modules from CPAN
375$@ 412$@
376EOF 413EOF
377 414
378 for mod in "$@"; do 415 for mod in "$@"; do
379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 416 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e 'notest install => "'"$mod"'"' \
380 || fatal "$mod: unable to install from CPAN" 417 || fatal "$mod: unable to install from CPAN"
381 done 418 done
382 rm -rf "$STATICPERL/build" 419 rm -rf "$STATICPERL/build"
383} 420}
384 421
400 rcd $mod 437 rcd $mod
401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 438 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
402 "$MAKE" distclean >/dev/null 2>&1 439 "$MAKE" distclean >/dev/null 2>&1
403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 440 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
404 "$MAKE" || fatal "$mod: error building module" 441 "$MAKE" || fatal "$mod: error building module"
405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 442 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
406 "$MAKE" distclean >/dev/null 2>&1 443 "$MAKE" distclean >/dev/null 2>&1
407 exit 0 444 exit 0
408 ) || exit $? 445 ) || exit $?
409 done 446 done
410} 447}
442#CAT mkbundle 479#CAT mkbundle
443MKBUNDLE 480MKBUNDLE
444} 481}
445 482
446bundle() { 483bundle() {
484 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 485 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 486 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache" 487 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE" 488 mkdir -p "$CACHE"
451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 489 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
470 ;; 508 ;;
471 instcpan ) 509 instcpan )
472 ( instcpan "$@" ) || exit 510 ( instcpan "$@" ) || exit
473 exit 511 exit
474 ;; 512 ;;
513 perl )
514 ( install ) || exit
515 exec "$PERL_PREFIX/bin/perl" "$@"
516 exit
517 ;;
475 cpan ) 518 cpan )
476 ( install ) || exit 519 ( install ) || exit
477 "$PERL_PREFIX/bin/cpan" "$@" 520 exec "$PERL_PREFIX/bin/cpan" "$@"
478 exit 521 exit
479 ;; 522 ;;
480 mkbundle ) 523 mkbundle )
481 ( install ) || exit 524 ( install ) || exit
482 bundle "$@" 525 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines